
options ls=78;
FILENAME dyst '~/multivar/muscdys.dat';
DATA  musc;
  INFILE dyst;
  INPUT num1 age month crekin hemo lacdeh pyrkin;
TITLE 'examp 3-5-3b';
PROC IML;
  USE musc;
  READ ALL var{crekin hemo lacdeh pyrkin}INTO Y1 where ( num1=1);
  READ ALL var{crekin hemo lacdeh pyrkin}INTO Y2 where (num1=2);
  n1 = NROW(y1);
  n2 = NROW(y2);
  yBAR1 = 1/N1*y1`*J(N1,1);
  yBAR2 = 1/N2*y2`*J(N2,1);
  S1 = 1/(N1-1)*y1`*(I(N1)-1/N1*J(N1))*y1;     
  S2 = 1/(N2-1)*y2`*(I(N2)-1/N2*J(N2))*y2;    
  Spl = 1/(N1+N2-2)*((N1-1)*S1+(N2-1)*S2);   
  T2 = N1*N2/(N1+N2)*(yBAR1-yBAR2)`*INV(Spl)*(yBAR1-yBAR2);


print ybar1,ybar2,s1,s2,spl,t2; 
  y1no1 = ybar1(|{2 3 4 },|);  
  y1no2 = ybar1(|{1 3 4 },|);  
  y1no3 = ybar1(|{1 2 4 },|);  
  y1no4 = ybar1(|{1 2 3 },|);  
  
  y2no1 = ybar2(|{2 3 4},|);  
  y2no2 = ybar2(|{1 3 4},|);  
  y2no3 = ybar2(|{1 2 4},|);  
  y2no4 = ybar2(|{1 2 3},|);  


  y1br1 = ybar1[1,1];
  y1br2 = ybar1[2,1];
  y1br3 = ybar1[3,1];
  y1br4 = ybar1[4,1];
  
  y2br1 = ybar2[1,1];
  y2br2 = ybar2[2,1];
  y2br3 = ybar2[3,1];
  y2br4 = ybar2[4,1];

  s1 = spl(|{2 3 4},{2 3 4}|);
  s2 = spl(|{1 3 4},{1 3 4}|);
  s3 = spl(|{1 2 4},{1 2 4}|);
  s4 = spl(|{1 2 3},{1 2 3}|);

  hT2no1 = N1*N2/(N1+N2)*(y1no1-y2no1)`*INV(s1)*(y1no1-y2no1);
print ht2no1;
********************************* Sxy vectors **************************;
  sm1 = spl(|{2 3 4},{1}|);
  sm2 = spl(|{1 3 4},{2}|);
  sm3 = spl(|{1 2 4},{3}|);
  sm4 = spl(|{1 2 3},{4}|);

********************************** Sxx elements ***********************;
  sx1 = spl[1,1];
  sx2 = spl[2,2];
  sx3 = spl[3,3];
  sx4 = spl[4,4];


******************************** Beta hat vectors **********************;
  b1 =inv(s1)*sm1;
  b2 =inv(s2)*sm2;
  b3 =inv(s3)*sm3;
  b4 =inv(s4)*sm4;


**************************** txhat elements *************************;
  txhat1 = b1`*(y1no1-y2no1)*sqrt(n1*n2)/(sqrt(sx1)*sqrt(n1+n2));
  txhat2 = b2`*(y1no2-y2no2)*sqrt(n1*n2)/(sqrt(sx2)*sqrt(n1+n2));
  txhat3 = b3`*(y1no3-y2no3)*sqrt(n1*n2)/(sqrt(sx3)*sqrt(n1+n2));
  txhat4 = b4`*(y1no4-y2no4)*sqrt(n1*n2)/(sqrt(sx4)*sqrt(n1+n2));
  

*************************** tx elements ****************************;
  tx1 = (y1br1-y2br1)*sqrt(n1*n2)/(sqrt(sx1)*sqrt(n1+n2));
  tx2 = (y1br2-y2br2)*sqrt(n1*n2)/(sqrt(sx2)*sqrt(n1+n2));
  tx3 = (y1br3-y2br3)*sqrt(n1*n2)/(sqrt(sx3)*sqrt(n1+n2));
  tx4 = (y1br4-y2br4)*sqrt(n1*n2)/(sqrt(sx4)*sqrt(n1+n2));

****************************** R square *****************************;
  rsq1 = sm1`*inv(s1)*sm1/sx1;
  rsq2 = sm2`*inv(s2)*sm2/sx2;
  rsq3 = sm3`*inv(s3)*sm3/sx3;
  rsq4 = sm4`*inv(s4)*sm4/sx4;


***************************** differences ****************************;
  diff1 = (txhat1-tx1)**2/(1-rsq1);
  diff2 = (txhat2-tx2)**2/(1-rsq2);
  diff3 = (txhat3-tx3)**2/(1-rsq3);
  diff4 = (txhat4-tx4)**2/(1-rsq4);



**************************** print ***********************************;
  print  'y1|y2,y3,y4',txhat1 tx1 rsq1 diff1,
         'y2|y1,y3,y4',txhat2 tx2 rsq2 diff2,
         'y3|y1,y2,y4',txhat3 tx3 rsq3 diff3,
         'y4|y1,y2,y3',txhat4 tx4 rsq4 diff4; 


quit;


ENDSAS;
ENDSAS;

