
options ls=80 nodate ;
data soil;
infile '~/multivar/soil.dat';
input group y1-y3;
run;

proc iml;
  use soil;
  read all var {y1 y2 y3 } into y1 where (group=1);
  read all var {y1 y2 y3 } into y2 where (group=2);

p=ncol(y1);
  n1 = nrow(y1);
  n2 = nrow(y2);
  y1bar = 1/n1*y1`*j(n1,1);
  y2bar = 1/n2*y2`*j(n2,1);
  s1 = 1/(n1-1)*y1`*(i(n1)-1/n1*j(n1))*y1;     
  s2 = 1/(n2-1)*y2`*(i(n2)-1/n2*j(n2))*y2;     
se=(s1/n1) +(s2/n2);
tstar2=(y1bar-y2bar)`*inv(se)*(y1bar-y2bar);
print y1bar,y2bar,s1,s2;
print tstar2 n1 n2 p;
*************************james approx test***************;
v1=inv(s1/n1);
v2=inv(s2/n2);
v=v1+v2;
tr1=(trace(inv(se)*inv(v1)))**2;
tr2=(trace(inv(se)*inv(v2)))**2;
frac1=1/(n1-1);
frac2=1/(n2-1);
sum1=(frac1*tr1)+(frac2*tr2);
a=1+((1/(2*p))*sum1);
trb1=trace(2*(inv(se)*inv(v1))**2);
trb2=trace(2*(inv(se)*inv(v2))**2);
sum2=(frac1*(trb1+tr1))+(frac2*(trb2+tr2));
b=(1/(2*p*(p+2)))*sum2;
cvchi=cinv(.95,p);
cvjim=cvchi*(a+b*cvchi);
print a b ;
print 'James` critical value is ' cvjim;
**********************************Yao approx test***************;
qf1=(y1bar-y2bar)`*inv(se)*(s1/n1)*inv(se)*(y1bar-y2bar);
qf2=(y1bar-y2bar)`*inv(se)*(s2/n2)*inv(se)*(y1bar-y2bar);
vinv=(1/tstar2**2)*((frac1*qf1**2)+(frac2*qf2**2));
vdf=1/vinv;
print 'Yao critical value is Hotelling`s T**2 with ' p 'and'	vdf;
******************************Johansen's approx test**********;
tlc1=trace((i(p)-inv(v)*v1)**2);
tlc2=trace((i(p)-inv(v)*v2)**2);

lc1=(trace(i(p)-inv(v)*v1))**2;
lc2=(trace(i(p)-inv(v)*v2))**2;
d=.5*frac1*(tlc1+lc1)+.5*frac2*(tlc2+lc2);
c=p+2*d-6*d/(p*(p-1)+2);
jov=((p*(p+2))/(3*d));
jots2=(jov*p*tstar2)/((jov-p+1)*c);
jots1=tstar2/c;
print d c jots1;
print 'Johansen`s test statistic ' jots2 'is approximatly a  Hotelling`s T with ';
print p 'and' jov;
*********************************Nel and van der Merwe***********;
num=trace(se**2)+(trace(se))**2;
den1=frac1*(trace((inv(v1))**2) +(trace(inv(v1)))**2);
den2=frac2*(trace((inv(v2))**2) +(trace(inv(v2)))**2);
nelv=num/(den1+den2);
print 'Nel and van der Merwe use' tstar2 'which is an approximate  ';
print  'Hotelling`s T with ' p 'and' nelv;


endsas;
