/* Example 4.10.5 */
options ls=72;
data new;
infile '/stat4_2/rvol2res/multivar/table4_9.dat';
input group y1 y2 y3 x1 x2;

proc glm outstat=e noprint;
class group;
model y1 y2 y3 x1 x2 = group/nouni;
manova h=group/;
run;

proc iml;
use e;
read all var {y1 y2 y3 x1 x2} into e where(_TYPE_ = 'ERROR');
read all var {y1 y2 y3 x1 x2} into h where(_TYPE_ = 'SS3');  

eyy = e[1:3,1:3];
eyx = e[1:3,4:5];
exy = e[4:5,1:3];
exx = e[4:5,4:5];

hxx = h[4:5,4:5];


print h e;

det_e = det(e);
det_eh = det(e+h);
det_ex = det(exx);
det_exhx = det(exx+hxx);

lambxy = det(e)/det(e+h);
lambx  = det(exx)/det(exx+hxx);
lambda1 = lambxy/lambx;
print det_e det_eh det_ex det_exhx lambda1;

*********** find lambda2 ***********;
matrix2 = eyx*inv(exx)*exy;
lambda2 = det(eyy-(eyx*inv(exx)*exy))/det(eyy);
top2 = det(eyy - (eyx*inv(exx)*exy));
bot2 = det(eyy);

print matrix2 top2 bot2 lambda2;

*********** find lambda 3 *********;

proc glm data =new outstat=e1 noprint;
class group;
model y1 y2 y3 x1 x2 = group/nouni;
where group=1;
manova h=group/;
run;

proc glm data = new outstat=e2 noprint;
class group;
model y1 y2 y3 x1 x2 = group/nouni;
where group=2;
manova h=group/;
run;

proc glm data = new outstat=e3 noprint;
class group;
model y1 y2 y3 x1 x2 = group/nouni;
where group=3;
manova h=group/;
run;

proc glm data = new outstat=e4 noprint;
class group;
model y1 y2 y3 x1 x2 = group/nouni;
where group=4;
manova h=group/;
run;

proc iml;
use e;
read all var {y1 y2 y3 x1 x2} into e where(_TYPE_ = 'ERROR');
use e1;
read all var {y1 y2 y3 x1 x2} into e1 where(_TYPE_ = 'ERROR');
use e2;
read all var {y1 y2 y3 x1 x2} into e2 where(_TYPE_ = 'ERROR');
use e3;
read all var {y1 y2 y3 x1 x2} into e3 where(_TYPE_ = 'ERROR');
use e4;
read all var {y1 y2 y3 x1 x2} into e4 where(_TYPE_ = 'ERROR');

eyy = e[1:3,1:3];
eyx = e[1:3,4:5];
exy = e[4:5,1:3];
exx = e[4:5,4:5];

eyx1 = e1[1:3,4:5];
exy1 = e1[4:5,1:3];
exx1 = e1[4:5,4:5];

eyx2 = e2[1:3,4:5];
exy2 = e2[4:5,1:3];
exx2 = e2[4:5,4:5];

eyx3 = e3[1:3,4:5];
exy3 = e3[4:5,1:3];
exx3 = e3[4:5,4:5];


eyx4 = e4[1:3,4:5];
exy4 = e4[4:5,1:3];
exx4 = e4[4:5,4:5];


summat = eyx1*inv(exx1)*exy1 + eyx2*inv(exx2)*exy2 
       + eyx3*inv(exx3)*exy3 + eyx4*inv(exx4)*exy4;


lambda3 = det(eyy - summat)/det(eyy-eyx*inv(exx)*exy);
top3 = det(eyy-summat);
bot3 = det(eyy-eyx*inv(exx)*exy);

print summat top3 bot3 lambda3;

