options ls=72;

data soil;

infile '~/multivar/football.dat';
input group y1 y2 y3 y4 y5 y6;
run; 
proc discrim data = soil method=normal pool=yes testdata=soil testlist;
class group;
var y1 y2 y3 y4 y5 y6;
run;
proc glm outstat=err noprint;
model y1-y6=group;
manova h=group;
run;
 
proc iml;
use soil;
read all var{y1 y2 y3 y4 y5 y6 } into g1 where(group=1);
read all var{y1 y2 y3 y4 y5 y6 } into g2 where(group=2);
read all var{y1 y2 y3 y4 y5 y6 } into g3 where(group=3);
use err;
read all var {y1 y2 y3 y4 y5 y6} into e where(_type_='ERROR');
reset print;
  N1 = NROW(g1);
  N2 = NROW(g2);
  N3 = NROW(g3);
n=n1+n2+n3;
  g1B = 1/N1*g1`*J(N1,1);
  g2B = 1/N2*g2`*J(N2,1);
  g3B = 1/N3*g3`*J(N3,1);
  
spl=e/(n-3);

y11=g1[1:1,1:6]`;
y13=g1[3:3,1:6]`;
ivs=inv(spl);
d11=(y11-g1b)`*ivs*(y11-g1b);
d12=(y11-g2b)`*ivs*(y11-g2b);
d13=(y11-g3b)`*ivs*(y11-g3b);

d31=(y13-g1b)`*ivs*(y13-g1b);
d32=(y13-g2b)`*ivs*(y13-g2b);
d33=(y13-g3b)`*ivs*(y13-g3b);

ep11=exp(-.5*d11);
ep12=exp(-.5*d12);
ep13=exp(-.5*d13);


ep31=exp(-.5*d31);
ep32=exp(-.5*d32);
ep33=exp(-.5*d33);

bot1=ep11+ep12+ep13;
bot3=ep31+ep32+ep33;

p11=ep11/bot1;
p12=ep12/bot1;
p13=ep13/bot1;

p31=ep31/bot3;
p32=ep32/bot3;
p33=ep33/bot3;


quit;
endsas;



