/* EXAMPLE 5.3.2 */
options ls=72;
filename c 'table1-3.dat';

DATA probe;
infile c;
input obs y1-y5;
run;


proc IML;
 use probe;  
 read all var{y1 y2 y3 y4 y5} into x;
  RESET noPRINT;
  MU = {30,25,40,25,30};
  n=nrow(x);
  p = ncol(x);
  v = n-1;
  XBAR = 1/N*X`*J(N,1);
  S = 1/(N-1)*X`*(I(N)-1/N*J(N))*X;
  T2 = N*(XBAR-MU)`*INV(S)*(XBAR-MU);
  print 'Part a',t2;

********************************* part b **************************************;
s1=s[1,1];
s2=s[2,2];
s3=s[3,3];
s4=s[4,4];
s5=s[5,5];


x1 = xbar[1,1];
x2 = xbar[2,1];
x3 = xbar[3,1];
x4 = xbar[4,1];
x5 = xbar[5,1];



****** tsq value for p=5, n-1 = 10 ******;
tval = sqrt(finv(.95,p,v-p+1)*v*p/(v-p+1));

up1 = x1 + tval*sqrt(s1/11);
down1 = x1 - tval*sqrt(s1/11);
up2 = x2 + tval*sqrt(s2/11);
down2 = x2 - tval*sqrt(s2/11);

up3 = x3 + tval*sqrt(s3/11);
down3 = x3 - tval*sqrt(s3/11);

up4 = x4 + tval*sqrt(s4/11);
down4 = x4 - tval*sqrt(s4/11);
up5 = x5 + tval*sqrt(s5/11);
down5 = x5 - tval*sqrt(s5/11);

print 'Part b - Simultaneous confidence intervals',down1 up1,down2 up2,
down3 up3,down4 up4, down5 up5;


******************************** part c *********************************;
tv = tinv(.995,10);
d1 = x1 - tv*sqrt(s1/11);
d2 = x2 - tv*sqrt(s2/11);
d3 = x3 - tv*sqrt(s3/11);
d4 = x4 - tv*sqrt(s4/11);
d5 = x5 - tv*sqrt(s5/11);


u1 = x1 + tv*sqrt(s1/11);
u2 = x2 + tv*sqrt(s2/11);
u3 = x3 + tv*sqrt(s3/11);
u4 = x4 + tv*sqrt(s4/11);
u5 = x5 + tv*sqrt(s5/11);


print 'Part c - Bonferroni intervals ', d1 u1,d2 u2,d3 u3,d4 u4,d5 u5;

***************************** part d ***********************************;
ta = j(p,1);
do i = 1 to p;
ta[i,] = (xbar[i,] - MU[i,1])*sqrt(n)/sqrt(s[i,i]);
end;
print ta;

quit;


