options ls=72;
filename c 'table1-3.dat';
DATA probe;
infile c;
input obs y1-y5;
run;

proc IML;
 use probe;  
 read all var{y1 y2 y3 y4 y5} into x;
  RESET noPRINT;
  MU = {30,25,40,25,30};
  n=nrow(x);
  XBAR = 1/N*X`*J(N,1);
  S = 1/(N-1)*X`*(I(N)-1/N*J(N))*X;
  Tsq = N*(XBAR-MU)`*INV(S)*(XBAR-MU);
  
  muno1 = mu(|{2 3 4 5},|);  
  muno2 = mu(|{1 3 4 5},|);  
  muno3 = mu(|{1 2 4 5},|);  
  muno4 = mu(|{1 2 3 5},|);  
  muno5 = mu(|{1 2 3 4},|);  
  mu1 =   mu[1,1];     
  mu2 =   mu[2,1];     
  mu3 =   mu[3,1];     
  mu4 =   mu[4,1];     
  mu5 =   mu[5,1];     

  yno1 = xbar(|{2 3 4 5},|);  
  yno2 = xbar(|{1 3 4 5},|);  
  yno3 = xbar(|{1 2 4 5},|);  
  yno4 = xbar(|{1 2 3 5},|);  
  yno5 = xbar(|{1 2 3 4},|);  
  x1 =   xbar[1,1];     
  x2 =   xbar[2,1];     
  x3 =   xbar[3,1];     
  x4 =   xbar[4,1];     
  x5 =   xbar[5,1];     

  s1 = s(|{2 3 4 5},{2 3 4 5}|);
  s2 = s(|{1 3 4 5},{1 3 4 5}|);
  s3 = s(|{1 2 4 5},{1 2 4 5}|);
  s4 = s(|{1 2 3 5},{1 2 3 5}|);
  s5 = s(|{1 2 3 4},{1 2 3 4}|);

  sm1 = s(|{2 3 4 5},{1}|);
  sm2 = s(|{1 3 4 5},{2}|);
  sm3 = s(|{1 2 4 5},{3}|);
  sm4 = s(|{1 2 3 5},{4}|);
  sm5 = s(|{1 2 3 4},{5}|);

  sx1 = s[1,1];
  sx2 = s[2,2];
  sx3 = s[3,3];
  sx4 = s[4,4];
  sx5 = s[5,5];



  b1 =inv(s1)*sm1;
  b2 =inv(s2)*sm2;
  b3 =inv(s3)*sm3;
  b4 =inv(s4)*sm4;
  b5 =inv(s5)*sm5;


  t1 = n*(yno1-muno1)`*inv(s1)*(yno1-muno1);
  t2 = n*(yno2-muno2)`*inv(s2)*(yno2-muno2);
  t3 = n*(yno3-muno3)`*inv(s3)*(yno3-muno3);
  t4 = n*(yno4-muno4)`*inv(s4)*(yno4-muno4);
  t5 = n*(yno5-muno5)`*inv(s5)*(yno5-muno5);

  txhat1 = b1`*(yno1-muno1)*sqrt(n)/sqrt(sx1);
  txhat2 = b2`*(yno2-muno2)*sqrt(n)/sqrt(sx2);
  txhat3 = b3`*(yno3-muno3)*sqrt(n)/sqrt(sx3);
  txhat4 = b4`*(yno4-muno4)*sqrt(n)/sqrt(sx4);
  txhat5 = b5`*(yno5-muno5)*sqrt(n)/sqrt(sx5);
  
  tx1 = (x1-mu1)*sqrt(n)/sqrt(sx1);
  tx2 = (x2-mu2)*sqrt(n)/sqrt(sx2);
  tx3 = (x3-mu3)*sqrt(n)/sqrt(sx3);
  tx4 = (x4-mu4)*sqrt(n)/sqrt(sx4);
  tx5 = (x5-mu5)*sqrt(n)/sqrt(sx5);

  rsq1 = sm1`*inv(s1)*sm1/sx1;
  rsq2 = sm2`*inv(s2)*sm2/sx2;
  rsq3 = sm3`*inv(s3)*sm3/sx3;
  rsq4 = sm4`*inv(s4)*sm4/sx4;
  rsq5 = sm5`*inv(s5)*sm5/sx5;

  tinc1 = (txhat1-tx1)**2/(1-rsq1); 
  tinc2 = (txhat2-tx2)**2/(1-rsq2); 
  tinc3 = (txhat3-tx3)**2/(1-rsq3); 
  tinc4 = (txhat4-tx4)**2/(1-rsq4); 
  tinc5 = (txhat5-tx5)**2/(1-rsq5); 

  print  'Problem 34 part a',
         txhat1 tx1 rsq1 tinc1,
         txhat2 tx2 rsq2 tinc2,
         txhat3 tx3 rsq3 tinc3,
         txhat4 tx4 rsq4 tinc4,
         txhat5 tx5 rsq5 tinc5;

********************** 34 b *****************************************;
   ybar1 =xbar[1:3];
   mubar1 = mu[1:3];
   s123 = s[1:3,1:3];
   p=3;
   q=2;

   t123 = n*(ybar1-mubar1)`*inv(s123)*(ybar1-mubar1);
   tfinal = (n-p-1)*(tsq-t123)/(n-1+t123);
   ffinal = (n-p-q)/2 *(tsq-t123)/(n-1+t123);
   print 'Problem 34 part b ',t123 tfinal ffinal;
***************************** 34 c ****************************************;
print 'Problem 34 part c';
mubarno1 = mu(|{2 3 4 5}|);
mubarno2 = mu(|{1 3 4 5}|);
mubarno3 = mu(|{1 2 4 5}|);
mubarno4 = mu(|{1 2 3 5}|);
mubarno5 = mu(|{1 2 3 4}|);
print mubarno1;
endsas;



%macro last(yno,ss,t,tfinal,ffinal);   /* yno = yvector, ss = s matrix */
   p=4;
   q=1;
/* this macro needs to use  mubarno# not mubar1 i.e. the ith iteration should 
use mubarnoi not mubar1 also it should call the macro last somewhere in the body of the program. To do 34c use code at the end of this file of or figure out how to use sas macros and fix this one.*/
   &t = n*(&yno-mubar1)`*inv(&ss)*(&yno-mubar1);
   &tfinal = (n-p-1)*(tsq-&t)/(n-1+&t);
   &ffinal = (n-p-q)/q*(tsq-&t)/(n-1+&t);
   print &tfinal &ffinal;

%mend;

%last(yno1,s1,t1,tfinal1,ffinal1);
%last(yno2,s2,t2,tfinal2,ffinal2);
%last(yno3,s3,t3,tfinal3,ffinal3);
%last(yno4,s4,t4,tfinal4,ffinal4);
%last(yno5,s5,t5,tfinal5,ffinal5);
quit;

/* This is the code that generated the answers for 3.34 part c*/
proc IML;
 use probe;  
 read all var{y1 y2 y3 y4 y5} into y;
  n = NROW(y);
p=4;
q=1;
  ybar = 1/n*y`*J(n,1);
  xbar = {30,25,40,25,30};
  S1 = 1/(n-1)*y`*(I(n)-1/n*J(n))*y;     
  HT2 = n*(ybar-xbar)`*INV(S1)*(ybar-xbar);
print 'PROBLEM 3-34c';
Swo1=s1[2:5,2:5];
Swo2=s1(|{1 3 4 5},{1 3 4 5}|);
Swo3=s1(|{1 2 4 5},{1 2 4 5}|);
Swo4=s1(|{1 2 3 5},{1 2 3 5}|);
Swo5=s1(|{1 2 3 4},{1 2 3 4}|);

ywo1=ybar(|{2 3 4 5},|);
xwo1=xbar(|{2 3 4 5},|);

ywo2=ybar(|{1 3 4 5},|);
xwo2=xbar(|{1 3 4 5},|);

ywo3=ybar(|{1 2 4 5},|);
xwo3=xbar(|{1 2 4 5},|);

ywo4=ybar(|{1 2 3 5 },|);
xwo4=xbar(|{1 2 3 5 },|);

ywo5=ybar(|{1 2 3 4 },|);
xwo5=xbar(|{1 2 3 4 },|);

  Two1 = n*(ywo1-xwo1)`*INV(Swo1)*(ywo1-xwo1);
  Two2 = n*(ywo2-xwo2)`*INV(Swo2)*(ywo2-xwo2);
  Two3 = n*(ywo3-xwo3)`*INV(Swo3)*(ywo3-xwo3);
  Two4 = n*(ywo4-xwo4)`*INV(Swo4)*(ywo4-xwo4);
  Two5 = n*(ywo5-xwo5)`*INV(Swo5)*(ywo5-xwo5);

v=(n-1);

ltwo1=(v-p)*(HT2-Two1)/(v+Two1);
ltwo2=(v-p)*(HT2-Two2)/(v+Two2);
ltwo3=(v-p)*(HT2-Two3)/(v+Two3);
ltwo4=(v-p)*(HT2-Two4)/(v+Two4);
ltwo5=(v-p)*(HT2-Two5)/(v+Two5);

 print Two1
 Two2
 Two3
 Two4
 Two5;

print  'These are the test statistics. They are Hotelling` s T**2',ltwo1
ltwo2
ltwo3
ltwo4
ltwo5;
ENDSAS;

