title 'Problem 3.42';
options ls=72;
filename c 'table3-8.dat';

DATA beetles;
infile c;
input obs group y1-y4;
run;


proc IML;
 use beetles;
 read all var{y1 y2 y3 y4} into y1 where(group=1);
 read all var{y1 y2 y3 y4} into y2 where(group=2);
  RESET noPRINT;
  
  n1=nrow(y1);
  n2=nrow(y2);

  yBAR1 = 1/N1*y1`*J(N1,1);
  yBAR2 = 1/N2*y2`*J(N2,1);

  S1 = 1/(N1-1)*y1`*(I(N1)-1/N1*J(N1))*y1;
  S2 = 1/(N2-1)*y2`*(I(N2)-1/N2*J(N2))*y2;

  spl = ((n1-1)*s1 + (n2-1)*s2)/(n1+n2-2);


  Tsq = N1*N2/(N1+N2) *(yBAR1-ybar2)`*INV(Spl)*(yBAR1-ybar2);
  
  y1no1 = ybar1(|{2 3 4 },|);  
  y1no2 = ybar1(|{1 3 4 },|);  
  y1no3 = ybar1(|{1 2 4 },|);  
  y1no4 = ybar1(|{1 2 3 },|);  
  
  y2no1 = ybar2(|{2 3 4},|);  
  y2no2 = ybar2(|{1 3 4},|);  
  y2no3 = ybar2(|{1 2 4},|);  
  y2no4 = ybar2(|{1 2 3},|);  



  y1br1 = ybar1[1,1];
  y1br2 = ybar1[2,1];
  y1br3 = ybar1[3,1];
  y1br4 = ybar1[4,1];
  
  y2br1 = ybar2[1,1];
  y2br2 = ybar2[2,1];
  y2br3 = ybar2[3,1];
  y2br4 = ybar2[4,1];

  s1 = spl(|{2 3 4},{2 3 4}|);
  s2 = spl(|{1 3 4},{1 3 4}|);
  s3 = spl(|{1 2 4},{1 2 4}|);
  s4 = spl(|{1 2 3},{1 2 3}|);

********************************* Sxy vectors **************************;
  sm1 = spl(|{2 3 4},{1}|);
  sm2 = spl(|{1 3 4},{2}|);
  sm3 = spl(|{1 2 4},{3}|);
  sm4 = spl(|{1 2 3},{4}|);

********************************** Sxx elements ***********************;
  sx1 = spl[1,1];
  sx2 = spl[2,2];
  sx3 = spl[3,3];
  sx4 = spl[4,4];


******************************** Beta hat vectors **********************;
  b1 =inv(s1)*sm1;
  b2 =inv(s2)*sm2;
  b3 =inv(s3)*sm3;
  b4 =inv(s4)*sm4;


**************************** txhat elements *************************;
  txhat1 = b1`*(y1no1-y2no1)*sqrt(n1*n2)/(sqrt(sx1)*sqrt(n1+n2));
  txhat2 = b2`*(y1no2-y2no2)*sqrt(n1*n2)/(sqrt(sx2)*sqrt(n1+n2));
  txhat3 = b3`*(y1no3-y2no3)*sqrt(n1*n2)/(sqrt(sx3)*sqrt(n1+n2));
  txhat4 = b4`*(y1no4-y2no4)*sqrt(n1*n2)/(sqrt(sx4)*sqrt(n1+n2));
  

*************************** tx elements ****************************;
  tx1 = (y1br1-y2br1)*sqrt(n1*n2)/(sqrt(sx1)*sqrt(n1+n2));
  tx2 = (y1br2-y2br2)*sqrt(n1*n2)/(sqrt(sx2)*sqrt(n1+n2));
  tx3 = (y1br3-y2br3)*sqrt(n1*n2)/(sqrt(sx3)*sqrt(n1+n2));
  tx4 = (y1br4-y2br4)*sqrt(n1*n2)/(sqrt(sx4)*sqrt(n1+n2));

****************************** R square *****************************;
  rsq1 = sm1`*inv(s1)*sm1/sx1;
  rsq2 = sm2`*inv(s2)*sm2/sx2;
  rsq3 = sm3`*inv(s3)*sm3/sx3;
  rsq4 = sm4`*inv(s4)*sm4/sx4;


***************************** differences ****************************;
  diff1 = (txhat1-tx1)**2/(1-rsq1);
  diff2 = (txhat2-tx2)**2/(1-rsq2);
  diff3 = (txhat3-tx3)**2/(1-rsq3);
  diff4 = (txhat4-tx4)**2/(1-rsq4);



**************************** print ***********************************;
  print  'y1|y2,y3,y4',txhat1 tx1 rsq1 diff1,
         'y2|y1,y3,y4',txhat2 tx2 rsq2 diff2,
         'y3|y1,y2,y4',txhat3 tx3 rsq3 diff3,
         'y4|y1,y2,y3',txhat4 tx4 rsq4 diff4; 


quit;


