options ls=80 nodate ;
data bug;
infile '~table3-8.dat';
  input id Group y1 y2 y3 y4;
run;

Proc iml;
  use bug;
  read all var {y1 y2 y3 y4} into y;
  p=ncol(y);
  y1 = y[1:19,];
  y2 = y[20:39,];
  n1 = nrow(y1);
  n2 = nrow(y2);
  y1bar = 1/n1*y1`*j(n1,1);
  y2bar = 1/n2*y2`*j(n2,1);
  s1 = 1/(n1-1)*y1`*(i(n1)-1/n1*j(n1))*y1;     
  s2 = 1/(n2-1)*y2`*(i(n2)-1/n2*j(n2))*y2;     
  spl = 1/(n1+n2-2)*((n1-1)*s1+(n2-1)*s2);     
  a=inv(spL)*(y1bar-y2bar);
  t2= n1*n2/(n1+n2)*(y1bar-y2bar)`*a;
*****************************simultaneous 95% CI********;
a1={1 0 0 0 };
a2={0 1 0 0 };
a3={0 0 1 0 };
a4={0 0 0 1 };
t2cv = Finv(.95,p,n1+n2-p-1) * (n1+n2-2)*p/(n1+n2-p-1);
cv=sqrt(t2cv) ;
mult=(n1+n2)/(n1*n2);
sci1up=a1*(y1bar-y2bar)+(cv*sqrt(mult*a1*spl*a1`));
sci1lo=a1*(y1bar-y2bar)-(cv*sqrt(mult*a1*spl*a1`));

sci2up=a2*(y1bar-y2bar)+(cv*sqrt(mult*a2*spl*a2`));
sci2lo=a2*(y1bar-y2bar)-(cv*sqrt(mult*a2*spl*a2`));

sci3up=a3*(y1bar-y2bar)+(cv*sqrt(mult*a3*spl*a3`));
sci3lo=a3*(y1bar-y2bar)-(cv*sqrt(mult*a3*spl*a3`));

sci4up=a4*(y1bar-y2bar)+(cv*sqrt(mult*a4*spl*a4`));
sci4lo=a4*(y1bar-y2bar)-(cv*sqrt(mult*a4*spl*a4`));
print 'Simultaneous 95% Confidence Intervals';
print sci1up sci1lo, sci2up sci2lo, sci3up sci3lo, sci4up sci4lo;
**************************Bonferroni 95% CI*********;
bonalp = 1-(.05/(2*p));
boncv = tinv(bonalp,n1+n2-2);

bci1up =a1*(y1bar-y2bar)+(boncv*sqrt(mult*a1*spl*a1`));
bci1lo =a1*(y1bar-y2bar)-(boncv*sqrt(mult*a1*spl*a1`));

bci2up =a2*(y1bar-y2bar)+(boncv*sqrt(mult*a2*spl*a2`));
bci2lo =a2*(y1bar-y2bar)-(boncv*sqrt(mult*a2*spl*a2`));

bci3up =a3*(y1bar-y2bar)+(boncv*sqrt(mult*a3*spl*a3`));
bci3lo =a3*(y1bar-y2bar)-(boncv*sqrt(mult*a3*spl*a3`));

bci4up =a4*(y1bar-y2bar)+(boncv*sqrt(mult*a4*spl*a4`));
bci4lo =a4*(y1bar-y2bar)-(boncv*sqrt(mult*a4*spl*a4`));





print 'Bonferroni 95% Confidence Intervals';
print bonalp boncv;
print bci1up bci1lo, bci2up bci2lo, bci3up bci3lo, bci4up bci4lo;
endsas;
