options ls=72;
 title 'Lam(x|y) = Lam(y,x)/Lam(y) ';

data apple;
infile 'tab4-10.dat';
input group block y1 y2 y3 y4 y5 y6 x1 x2;

********************** manova stats for all variables *************;
proc glm data=apple outstat=e;
class group; 
model y1 - y6 = group; 
manova h=group/;
run;
proc print ;
****************** for part a ******************;

proc glm data=apple;
 class group;
 model y3 y4 y5 y6 = group/nouni;        
manova h=group;
run;
      
******************* for part b *****************;
proc glm data=apple;
 class group;
 model y2 y3 y4 y5 y6 = group/nouni;        
manova h=group;
title 'y1 adjusted for others';
run;

proc glm data=apple;
 class group;
 model y1 y3 y4 y5 y6 = group/nouni;        
manova h=group;
title 'y2 adjusted for others';
run;

proc glm data=apple;
 class group;
 model y1 y2 y4 y5 y6 = group/nouni;    
manova h=group;
title 'y3 adjusted for others';
run;

proc glm data=apple;
 class group;
 model y1 y2 y3 y5 y6 = group/nouni; 
manova h=group;
title 'y4 adjusted for others';
run;

proc glm data = apple;
 class group;
 model y1 y2 y3 y4 y6 = group/nouni;        
manova h=group;
title 'y5 adjusted for others';
run;

proc glm data=apple;
 class group;
 model y1 y2 y3 y4 y5 = group/nouni;    
manova h=group;
title 'y6 adjusted for others';
run;

********************** for parts c and d *******************************;

proc iml;
use apple;     
read all var {y1 y2 y3 y4 y5 y6} into y;
use e; 
read all var {y1 y2 y3 y4 y5 y6} into emat where(_type_ = "ERROR");
read all var {y1 y2 y3 y4 y5 y6} into hmat where(_type_ = "SS3");

x1=y[1:10,1:6];
x2=y[11:21,1:6];
x3=y[22:32,1:6];
x4=y[33:42,1:6];
p=ncol(y);
k=4;
n1=nrow(x1);
n2=nrow(x2);
n3=nrow(x3);
n4=nrow(x4);
v1=n1-1;
v2=n2-1;
v3=n3-1;
v4=n4-1;


ve = v1+v2+v3+v4;

s1=1/(n1-1)*x1`*(I(n1)-1/n1*J(n1))*x1;
s2=1/(n2-1)*x2`*(I(n2)-1/n2*J(n2))*x2;
s3=1/(n3-1)*x3`*(I(n3)-1/n3*J(n3))*x3;
s4=1/(n4-1)*x4`*(I(n4)-1/n4*J(n4))*x4;
spl = (v1*s1 + v2*s2 + v3*s3 + v4*s4)/ve;


******************************* to find the Rsqe's ******************;
exx1 = emat[1,1];
exy1 = emat(|{1},{2 3 4 5 6}|);
eyy1 = emat(|{2 3 4 5 6},{2 3 4 5 6}|);

exx2 = emat[2,2];
exy2 = emat(|{2},{1 3 4 5 6}|);
eyy2 = emat(|{1 3 4 5 6},{1 3 4 5 6}|);

exx3 = emat[3,3];
exy3 = emat(|{3},{1 2 4 5 6}|);
eyy3 = emat(|{1 2 4 5 6},{1 2 4 5 6}|);


exx4 = emat[4,4];
exy4 = emat(|{4},{1 2 3 5 6}|);
eyy4 = emat(|{1 2 3 5 6},{1 2 3 5 6}|);


exx5 = emat[5,5];
exy5 = emat(|{5},{1 2 3 4 6}|);
eyy5 = emat(|{1 2 3 4 6},{1 2 3 4 6}|);


exx6 = emat[6,6];
exy6 = emat(|{6},{1 2 3 4 5}|);
eyy6 = emat(|{1 2 3 4 5},{1 2 3 4 5}|);



rsqe1 = exy1 * inv(eyy1) * exy1`/exx1;
rsqe2 = exy2 * inv(eyy2) * exy2`/exx2;
rsqe3 = exy3 * inv(eyy3) * exy3`/exx3;
rsqe4 = exy4 * inv(eyy4) * exy4`/exx4;
rsqe5 = exy5 * inv(eyy5) * exy5`/exx5;
rsqe6 = exy6 * inv(eyy6) * exy6`/exx6;


******************************* to find the Rsqe+h's ******************;
hxx1 = hmat[1,1];
hxy1 = hmat(|{1},{2 3 4 5 6}|);
Hyy1 = hmat(|{2 3 4 5 6},{2 3 4 5 6}|);

hxx2 = hmat[2,2];
hxy2 = hmat(|{2},{1 3 4 5 6}|);
hyy2 = hmat(|{1 3 4 5 6},{1 3 4 5 6}|);

hxx3 = hmat[3,3];
hxy3 = hmat(|{3},{1 2 4 5 6}|);
hyy3 = hmat(|{1 2 4 5 6},{1 2 4 5 6}|);


hxx4 = hmat[4,4];
hxy4 = hmat(|{4},{1 2 3 5 6}|);
hyy4 = hmat(|{1 2 3 5 6},{1 2 3 5 6}|);


hxx5 = hmat[5,5];
hxy5 = hmat(|{5},{1 2 3 4 6}|);
hyy5 = hmat(|{1 2 3 4 6},{1 2 3 4 6}|);


hxx6 = hmat[6,6];
hxy6 = hmat(|{6},{1 2 3 4 5}|);
hyy6 = hmat(|{1 2 3 4 5},{1 2 3 4 5}|);


rsqeh1 = (exy1+hxy1)*inv(eyy1+hyy1)*(exy1+hxy1)`/(exx1+hxx1);
rsqeh2 = (exy2+hxy2)*inv(eyy2+hyy2)*(exy2+hxy2)`/(exx2+hxx2);
rsqeh3 = (exy3+hxy3)*inv(eyy3+hyy3)*(exy3+hxy3)`/(exx3+hxx3);
rsqeh4 = (exy4+hxy4)*inv(eyy4+hyy4)*(exy4+hxy4)`/(exx4+hxx4);
rsqeh5 = (exy5+hxy5)*inv(eyy5+hyy5)*(exy5+hxy5)`/(exx5+hxx5);
rsqeh6 = (exy6+hxy6)*inv(eyy6+hyy6)*(exy6+hxy6)`/(exx6+hxx6);


print '******************  Part C *********************** ';
print rsqeh1 rsqeh2 rsqeh3 rsqeh4 rsqeh5 rsqeh6;
print rsqe1 rsqe2 rsqe3 rsqe4 rsqe5 rsqe6;
print 'Fxs are in part a';
print 'Lambdas are in part b';


lnm = .5*(v1*log(det(s1)) + v2*log(det(s2)) + v3*log(det(s3)) + v4*log(det(s4)))      -
.5*ve*log(det(spl));
         

******* calculate c1, u (X**2 approximation) *********;
c1=(1/v1 + 1/v2 + 1/v3 + 1/v4 - (1/ve))*
   (2*p*p + 3*p - 1)/(6*(p+1)*(k-1));

u = -2*(1-c1)*lnm;

************ calculate c2, a1, a2, b1, b2   (F approximation) *******;

c2 = (p-1)*(p+2)/(6*(k-1))*
     (1/v1**2 + 1/v2**2 + 1/v3**2 + 1/v4**2 - 1/ve**2);

a1 = 1/2*(k-1)*p*(p+1);
a2 = (a1+2)/abs(c2-c1**2);
b1 = (1-c1-a1/a2)/a1;
b2 = (1-c1-2/a2)/a2;

if c2 > c1*c1 then f = -2*b1*lnm;   
if c2 < c1*c1 then f = a2*b2*lnm/(a1*(1+2*b2*lnm));
print '******************* Part d **********************';
print a1 a2 b1 b2 c1 c2;
print u f;




