options ls=72;

data apple;  
infile 'tab4-10.dat';  
input group block y1 y2 y3 y4 y5 y6 x1 x2;



/************** the full and reduced models to find lambda 1 *************/
proc glm data = apple outstat=e;
class group;
model y1-y6 x1 x2 = group/nouni;
manova h=group; 
title 'full model';
run;

proc glm data = apple;
class group;
model x1 x2 = group/nouni;
manova h=group/summary;
title 'reduced model';
run;




******** find lambda 2 and 3 using the outstat option in proc glm which ****;
******** outputs the e matrix to a data set **************************;

data all g1 g2 g3 g4;
set apple;
if group=1 then output g1;
else if group=2 then output g2;
else if group=3 then output g3;
else if group=4 then output g4;
output all;
run;


proc glm data = g1 outstat=e1 noprint; 
class group;
model y1 y2 y3 y4 y5 y6 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group 1';
run;

proc glm data = g2 outstat=e2 noprint; 
class group;
model y1 y2 y3 y4 y5 y6 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group 2';
run;

proc glm data = g3 outstat=e3 noprint; 
class group;
model y1 y2 y3 y4 y5 y6 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group 3';
run;

proc glm data = g4 outstat=e4 noprint; 
class group;
model y1 y2 y3 y4 y5 y6 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group 4';
run;



proc iml;
reset noprint;
use e;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e where(_TYPE_='ERROR');
use e1;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e1 where(_TYPE_='ERROR');
use e2;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e2 where(_TYPE_='ERROR');

use e3;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e3 where(_TYPE_='ERROR');
use e4;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e4 where(_TYPE_='ERROR');

eyx1 = e1[1:6,7:8];
exy1 = e1[7:8,1:6];
exx1 = e1[7:8,7:8];

eyx2 = e2[1:6,7:8];
exy2 = e2[7:8,1:6];
exx2 = e2[7:8,7:8];

eyx3 = e3[1:6,7:8];
exy3 = e3[7:8,1:6];
exx3 = e3[7:8,7:8];

eyx4 = e4[1:6,7:8];
exy4 = e4[7:8,1:6];
exx4 = e4[7:8,7:8];


eyy = e[1:6,1:6];
eyx  = e[1:6,7:8];
exy  = e[7:8,1:6];
exx  = e[7:8,7:8];
n=nrow(e);


summat = eyx1*inv(exx1)*exy1 + eyx2*inv(exx2)*exy2 
       + eyx3*inv(exx3)*exy3 + eyx4*inv(exx4)*exy4;

lambda2 = det(inv(eyy))*det(eyy-eyx*inv(exx)*exy);
lambda3 = det(eyy - summat)/(det(eyy-eyx*inv(exx)*exy));

print lambda2,lambda3, n;




