options ls=72 nodate nonumber;
data new;
infile 'tab4-10.dat';
input treat block y1-y6 x1 x2;
run;

proc glm outstat=er noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
run;
proc iml;
use er;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into hb where(_TYPE_ = 'SS3' & _SOURCE_
='BLOCK');
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into ht where(_TYPE_ = 'SS3' & _SOURCE_ ='TREAT');
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into htb where(_TYPE_ = 'SS3' & _SOURCE_
='TREAT*BLOCK');


eyy = e[1:6,1:6];
eyx = e[1:6,7:8];
exy = e[7:8,1:6];
exx = e[7:8,7:8];

hbxx = hb[7:8,7:8];
htxx = ht[7:8,7:8];
htbxx = htb[7:8,7:8];


det_e = det(e);
det_ex = det(exx);

/*******Find lambda 1 for treat to test Ho1*/

deteht = det(e+ht);
detexhtx = det(exx+htxx);
lambxy = det(e)/det(e+ht);
lambx  = det(exx)/det(exx+htxx);
lambda1 = lambxy/lambx;
print 'Lambda 1 for treatment to test Ho1';
print det_e deteht det_ex detexhtx lambda1;

/*******Find lambda 1 for block to test Ho1*/
detehb = det(e+hb);
detexhbx = det(exx+hbxx);
lambxy = det(e)/det(e+hb);
lambx  = det(exx)/det(exx+hbxx);
lambda1 = lambxy/lambx;
print 'Lambda 1 for block to test Ho1';
print det_e detehb det_ex detexhbx lambda1;




/*Find lambda 1 for treat*block to test Ho1*/

detehtb = det(e+htb);
dexhtbx = det(exx+htbxx);
lambxy = det(e)/det(e+htb);
lambx  = det(exx)/det(exx+htbxx);
lambda1 = lambxy/lambx;
print 'Lambda 1 for treatment*block to test Ho1';
print det_e detehtb det_ex dexhtbx lambda1;


*********** find lambda2 ***********;
matrix2 = eyx*inv(exx)*exy;
lambda2 = det(eyy-(eyx*inv(exx)*exy))/det(eyy);
top2 = det(eyy - (eyx*inv(exx)*exy));
bot2 = det(eyy);
print 'Lambda 2 to test Ho2';
print    top2 bot2 lambda2;
quit;



*********** find lambda3 for all  ***********;
proc glm data =new outstat=et1 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=1;
run;

proc glm data = new outstat=et2 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=2;
run;

proc glm data = new outstat=et3 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=3;
run;

proc glm data = new outstat=et4 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=4;
run;



proc glm data =new outstat=eb1 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where block=1;
run;

proc glm data = new outstat=eb2 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where block=2;
run;

proc glm data = new outstat=eb3 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where block=3;
run;


proc glm data = new outstat=eb4 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where block=4;
run;


proc glm data = new outstat=etb1 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=1 & block=1;
run;

proc glm data = new outstat=etb2 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=1 & block=2;
run;

proc glm data = new outstat=etb3 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=1 & block=3;
run;
proc glm data = new outstat=etb4 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=1 & block=4;
run;

proc glm data = new outstat=etb5 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=2 & block=1;
run;

proc glm data = new outstat=etb6 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=2 & block=2;
run;

proc glm data = new outstat=etb7 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=2 & block=3;
run;

proc glm data = new outstat=etb8 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=2 & block=4;
run;

proc glm data = new outstat=etb9 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=3 & block=1;
run;

proc glm data = new outstat=etb10 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=3 & block=2;
run;

proc glm data = new outstat=etb11 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=3 & block=3;
run;

proc glm data = new outstat=etb12 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=3 & block=4;
run;

proc glm data = new outstat=etb13 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=4 & block=1;
run;

proc glm data = new outstat=etb14 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=4 & block=2;
run;

proc glm data = new outstat=etb15 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=4 & block=3;
run;

proc glm data = new outstat=etb16 noprint;
class treat block;
model y1-y6  x1 x2 = treat|block/nouni;
manova h=_all_/;
where treat=4 & block=4;
run;
****************Ho3 for treat********;
proc iml;
use er;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use et1;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e1 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use et2;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e2 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use et3;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e3 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use et4;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e4 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');

eyy = e[1:6,1:6];
eyx = e[1:6,7:8];
exy = e[7:8,1:6];
exx = e[7:8,7:8];

eyx1 = e1[1:6,7:8];
exy1 = e1[7:8,1:6];
exx1 = e1[7:8,7:8];

eyx2 = e2[1:6,7:8];
exy2 = e2[7:8,1:6];
exx2 = e2[7:8,7:8];

eyx3 = e3[1:6,7:8];
exy3 = e3[7:8,1:6];
exx3 = e3[7:8,7:8];

eyx4 = e4[1:6,7:8];
exy4 = e4[7:8,1:6];
exx4 = e4[7:8,7:8];

summat = eyx1*inv(exx1)*exy1 + eyx2*inv(exx2)*exy2 
       + eyx3*inv(exx3)*exy3 + eyx4*inv(exx4)*exy4;


lambda3 = det(eyy - summat)/det(eyy-eyx*inv(exx)*exy);
top3 = det(eyy-summat);
bot3 = det(eyy-eyx*inv(exx)*exy);
print 'Ho3 for treatment';
print summat top3 bot3 lambda3;
quit;

****************Ho3 for Block********;
proc iml;
use er;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use eb1;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e1 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use eb2;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e2 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use eb3;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e3 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use eb4;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e4 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');

eyy = e[1:6,1:6];
eyx = e[1:6,7:8];
exy = e[7:8,1:6];
exx = e[7:8,7:8];

eyx1 = e1[1:6,7:8];
exy1 = e1[7:8,1:6];
exx1 = e1[7:8,7:8];

eyx2 = e2[1:6,7:8];
exy2 = e2[7:8,1:6];
exx2 = e2[7:8,7:8];

eyx3 = e3[1:6,7:8];
exy3 = e3[7:8,1:6];
exx3 = e3[7:8,7:8];

eyx4 = e4[1:6,7:8];
exy4 = e4[7:8,1:6];
exx4 = e4[7:8,7:8];

summat = eyx1*inv(exx1)*exy1 + eyx2*inv(exx2)*exy2 
       + eyx3*inv(exx3)*exy3 + eyx4*inv(exx4)*exy4;


lambda3 = det(eyy - summat)/det(eyy-eyx*inv(exx)*exy);
top3 = det(eyy-summat);
bot3 = det(eyy-eyx*inv(exx)*exy);
print 'Ho3 for block';
print summat top3 bot3 lambda3;
quit;

****************Ho3 for Treat*Block********;

proc iml;
use er;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb1;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e1 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb2;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e2 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb3;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e3 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb4;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e4 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');

use etb5;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e5 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb6;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e6 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb7;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e7 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb8;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e8 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');


use etb9;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e9 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb10;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e10 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb11;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e11 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb12;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e12 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');

use etb13;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e13 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb14;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e14 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb15;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e15 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');
use etb16;
read all var {y1 y2 y3 y4 y5 y6 x1 x2} into e16 where(_TYPE_ = 'ERROR' & _SOURCE_
='ERROR');


eyy = e[1:6,1:6];
eyx = e[1:6,7:8];
exy = e[7:8,1:6];
exx = e[7:8,7:8];

eyx1 = e1[1:6,7:8];
exy1 = e1[7:8,1:6];
exx1 = e1[7:8,7:8];

eyx2 = e2[1:6,7:8];
exy2 = e2[7:8,1:6];
exx2 = e2[7:8,7:8];

eyx3 = e3[1:6,7:8];
exy3 = e3[7:8,1:6];
exx3 = e3[7:8,7:8];

eyx4 = e4[1:6,7:8];
exy4 = e4[7:8,1:6];
exx4 = e4[7:8,7:8];

eyx5 = e5[1:6,7:8];
exy5 = e5[7:8,1:6];
exx5 = e5[7:8,7:8];

eyx6 = e6[1:6,7:8];
exy6 = e6[7:8,1:6];
exx6 = e6[7:8,7:8];

eyx7 = e7[1:6,7:8];
exy7 = e7[7:8,1:6];
exx7 = e7[7:8,7:8];

eyx8 = e8[1:6,7:8];
exy8 = e8[7:8,1:6];
exx8 = e8[7:8,7:8];

eyx9 = e9[1:6,7:8];
exy9 = e9[7:8,1:6];
exx9 = e9[7:8,7:8];

eyx10 = e10[1:6,7:8];
exy10 = e10[7:8,1:6];
exx10 = e10[7:8,7:8];

eyx11 = e11[1:6,7:8];
exy11 = e11[7:8,1:6];
exx11 = e11[7:8,7:8];

eyx12 = e12[1:6,7:8];
exy12 = e12[7:8,1:6];
exx12 = e12[7:8,7:8];

eyx13 = e13[1:6,7:8];
exy13 = e13[7:8,1:6];
exx13 = e13[7:8,7:8];

eyx14 = e14[1:6,7:8];
exy14 = e14[7:8,1:6];
exx14 = e14[7:8,7:8];

eyx15 = e15[1:6,7:8];
exy15 = e15[7:8,1:6];
exx15 = e15[7:8,7:8];

eyx16 = e16[1:6,7:8];
exy16 = e16[7:8,1:6];
exx16 = e16[7:8,7:8];


/*print exx1 exx2 exx3 exx4 exx5 exx6 exx7 exx8 exx9 exx10
exx11 exx12 exx13 exx14 exx15 exx16;*/

su1 = eyx1*ginv(exx1)*exy1 + eyx2*ginv(exx2)*exy2 
       + eyx3*ginv(exx3)*exy3 + eyx4*ginv(exx4)*exy4;

su2 = eyx5*ginv(exx5)*exy5 + eyx6*ginv(exx6)*exy6 
       + eyx7*ginv(exx7)*exy7 + eyx8*ginv(exx8)*exy8;

su3 = eyx9*ginv(exx9)*exy9 + eyx10*ginv(exx10)*exy10 
       + eyx11*ginv(exx11)*exy11 + eyx12*ginv(exx12)*exy12;

su4 = eyx13*ginv(exx13)*exy13 + eyx14*ginv(exx14)*exy14 
       + eyx15*ginv(exx15)*exy15 + eyx16*ginv(exx16)*exy16;

summat=su1+su2+su3+su4;

lambda3 = det(eyy - summat)/det(eyy-eyx*inv(exx)*exy);
top3 = det(eyy-summat);
bot3 = det(eyy-eyx*inv(exx)*exy);
print 'Ho3 for treatment*block';
print summat top3 bot3 lambda3;
quit;

endsas;
