
options ls=72;

data biochem;
infile 'tab4-11.dat';
input group y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2;

/******************* find the lambdas for the full and reduced models ****/
proc glm data =biochem outstat=e;
class group;
model y1-y11 x1 x2 = group/nouni;
title 'full model';
manova h=group;
run;


proc glm data =biochem;
class group;
model x1 x2 = group/nouni;
title 'reduced model';
manova h=group;
run;


/********************** to find lambda 2 and 3 ************************/
/***** the outstat option puts the e matrix into a data set ***********/
options ls=72;

data all g1 g2 g3 g4;
set biochem; 
if group=1 then output g1;
else if group=2 then output g2;
else if group=3 then output g3;
else if group=4 then output g4;
output all;
run;


proc glm data = all outstat=e noprint;
class group;
model y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group all';
run;

proc glm data = g1 outstat=e1 noprint; 
class group;
model y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group 1';
run;
     
proc glm data = g2 outstat=e2 noprint; 
class group;
model y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group 2';
run;
 
proc glm data = g3 outstat=e3 noprint; 
class group;
model y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group 3';
run;
 
proc glm data = g4 outstat=e4 noprint; 
class group;
model y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2 = group/nouni;
manova h=group/printe;
title 'Group 4';
run;



proc iml;
reset noprint;
use e;
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2} into e;
use e1;
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2} into e1;
use e2;
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2} into e2;

use e3;
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2} into e3;
use e4;
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2} into e4;


eyx1 = e1[1:11,12:13];
exy1 = e1[12:13,1:11];
exx1 = e1[12:13,12:13];


eyx2 = e2[1:11,12:13];
exy2 = e2[12:13,1:11];
exx2 = e2[12:13,12:13];

eyx3 = e3[1:11,12:13];
exy3 = e3[12:13,1:11];
exx3 = e3[12:13,12:13];

eyx4 = e4[1:11,12:13];
exy4 = e4[12:13,1:11];
exx4 = e4[12:13,12:13];

eyy = E[1:11,1:11];
eyx  = E[1:11,12:13];
exy  = E[12:13,1:11];
exx  = E[12:13,12:13];


summat = eyx1*inv(exx1)*exy1 + eyx2*inv(exx2)*exy2 
       + eyx3*inv(exx3)*exy3 + eyx4*inv(exx4)*exy4;

lambda2 = det(inv(eyy))*det(eyy-eyx*inv(exx)*exy);
lambda3 = det(eyy - summat)/(det(eyy-eyx*inv(exx)*exy));

print lambda2, lambda3;

