options ls=80 nodate ;
data soil;
infile 'table3.6.dat';
input group y1-y3;
run;

proc iml;
  use soil;
  read all var {y1 y2 y3} into x;
  n = nrow(x);
  p = ncol(x);
  x1 = x[1:13,];
  x2 = x[14:23,];

  n1 = nrow(x1);
  n2 = nrow(x2);
  x1BAR = 1/n1*x1`*J(n1,1);
  x2BAR = 1/n2*x2`*J(n2,1);
  v1 = n1-1;
  v2 = n2-1;
  v = v1+v2;
  S1 = 1/(n1-1)*x1`*(I(n1)-1/n1*J(n1))*x1;
  S2 = 1/(n2-1)*x2`*(I(n2)-1/n2*J(n2))*x2;
  Spl =(1/v)*(v1*S1+v2*S2);
  detS1 = det(S1);
  detS2 = det(S2);
  detSpl = det(Spl);

  lnm=0.5*((v1*log(detS1)+v2*log(detS2))-v*log(detSpl));

  k=2;

  c1 = ((1/v1+1/v2)-1/v)*(((2*p**2)+(3*p) -1)/(6*(p+1)*(k-1)));

  u = -2*(1-c1)*lnm;

 c2 = ((1/v1**2+1/v2**2)-1/v**2)*((p-1)*(p+2)/(6*(k-1)));

  a1 = .5*(k-1)*p*(p+1);
  a2 = (a1+2)/ABS(c2-c1**2);
  b1 = (1-c1-a1/a2)/a1;
  b2 = (1-c1-2/a2)/a2;
  print  lnm c1 u c2 a1 a2 b1 b2;
  START fvalue;
    IF c2>c1**2 then DO;
      F = -2*b1*lnm;
      print F;
      end;
    ELSE DO;
      F = -a2*b2*lnm/(a1*(1+2*b2*lnm));
      print F;
      end;
   finish;
  run fvalue;
endsas;
