/** Chapter 5.18 **/

options ls=72;

DATA beetle;
  INFILE 'table3-8.dat';
  INPUT obs species y1 y2 y3 y4;


proc iml;
use beetle;
read all var{y1 y2 y3 y4} into x;

x1=x[1:19,];
x2=x[20:39,];
n1=nrow(x1);
n2=nrow(x2);
p=ncol(x);
  S1 = 1/(N1-1)*X1`*(I(N1)-1/N1*J(N1))*X1;     /* W1 = X1`*(I(N1)-1/N1*J(N1))*X1 */
  S2 = 1/(N2-1)*X2`*(I(N2)-1/N2*J(N2))*X2;     /* W2 = X2`*(I(N2)-1/N2*J(N2))*X2 */
Spl=1/(n1+n2-2)*((n1-1)*S1+(n2-1)*S2);
xbar1=x1[+,]/n1;
xbar1=xbar1`;
xbar2=x2[+,]/n2;
xbar2=xbar2`;
a=inv(Spl)*(xbar1-xbar2);
sa=repeat(1,p,1);
do i=1 to p;
  sa[i]=sqrt(Spl[i,i])*a[i];
end;
t2=n1*n2/(n1+n2)*(xbar1-xbar2)`*inv(Spl)*(xbar1-xbar2);

x11=xbar1[{2 3 4}];
x21=xbar2[{2 3 4}];
sp1=Spl[{2 3 4},{2 3 4}];
su1=Spl[{2 3 4},1];
s11=Spl[1,1];
t21=n1*n2/(n1+n2)*(x11-x21)`*inv(sp1)*(x11-x21);
x12=xbar1[{1 3 4}];
x22=xbar2[{1 3 4}];
sp2=Spl[{1 3 4},{1 3 4}];
su2=Spl[{1 3 4},2];
s22=Spl[2,2];
t22=n1*n2/(n1+n2)*(x12-x22)`*inv(sp2)*(x12-x22);
x13=xbar1[{1 2 4}];
x23=xbar2[{1 2 4}];
sp3=Spl[{1 2 4},{1 2 4}];
su3=Spl[{1 2 4},3];
s33=Spl[3,3];
t23=n1*n2/(n1+n2)*(x13-x23)`*inv(sp3)*(x13-x23);
x14=xbar1[{1 2 3}];
x24=xbar2[{1 2 3}];
sp4=Spl[{1 2 3},{1 2 3}];
su4=Spl[{1 2 3},4];
s44=Spl[4,4];
t24=n1*n2/(n1+n2)*(x14-x24)`*inv(sp4)*(x14-x24);
f1=(n1+n2-2-p+1)*(t2-t21)/(n1+n2-2+t21);
f2=(n1+n2-2-p+1)*(t2-t22)/(n1+n2-2+t22);
f3=(n1+n2-2-p+1)*(t2-t23)/(n1+n2-2+t23);
f4=(n1+n2-2-p+1)*(t2-t24)/(n1+n2-2+t24);
p1=1-probf(f1,1,n1+n2-2-p+1);
p2=1-probf(f2,1,n1+n2-2-p+1);
p3=1-probf(f3,1,n1+n2-2-p+1);
p4=1-probf(f4,1,n1+n2-2-p+1);


print '# 5.16';

D1=(xbar1[1]-xbar2[1])/sqrt(Spl[1,1]);
D2=(xbar1[2]-xbar2[2])/sqrt(Spl[2,2]);
D3=(xbar1[3]-xbar2[3])/sqrt(Spl[3,3]);
D4=(xbar1[4]-xbar2[4])/sqrt(Spl[4,4]);
B1=inv(sp1)*su1;
B2=inv(sp2)*su2;
B3=inv(sp3)*su3;
B4=inv(sp4)*su4;
R21=su1`*B1/s11;
R22=su2`*B2/s22;
R23=su3`*B3/s33;
R24=su4`*B4/s44;
Dh1=B1`*(x11-x21)/sqrt(Spl[1,1]);
Dh2=B2`*(x12-x22)/sqrt(Spl[2,2]);
Dh3=B3`*(x13-x23)/sqrt(Spl[3,3]);
Dh4=B4`*(x14-x24)/sqrt(Spl[4,4]);

print D1 Dh1 R21;
print D2 Dh2 R22;
print D3 Dh3 R23;
print D4 Dh4 R24;

print '# 5.16b';
a0={6,-3,-2,-3};
t20=(a0`*(xbar1-xbar2))**2/((n1+n2)/(n1*n2)*a0`*Spl*a0);
f0=(n1+n2-2-p+1)*(t2-t20)/(n1+n2-2+t20);
p0=1-probf(f0,p-1,n1+n2-2-p+1);
print  t2 t20  f0 p0;


