options ls=72;

data app;
infile 'tab4-10.dat';  
input treat block y1 y2 y3 y4 y5 y6 x1 x2;
run;


proc candisc out=cand;
class treat;
var y1 y2 y3 y4 y5 y6;
run;


proc glm data = app outstat=all noprint;
class treat;
model y1-y6 = treat/nouni;
manova h=treat;
run;


proc glm data = app outstat=no1 noprint;
class treat;
model y2-y6 = treat/nouni;
manova h=treat;
run;


proc glm data = app outstat=no2 noprint;
class treat;
model y1 y3-y6 = treat/nouni;
manova h=treat;
run;


proc glm data = app outstat=no3 noprint;
class treat;
model y1 y2 y4-y6 = treat/nouni;
manova h=treat;
run;

proc glm data = app outstat=no4 noprint;
class treat;
model y1-y3 y5 y6 = treat/nouni;
manova h=treat;
run;


proc glm data = app outstat=no5 noprint;
class treat;
model y1-y4 y6 = treat/nouni;
manova h=treat;
run;

proc glm data = app outstat=no6 noprint;
class treat;
model y1-y5 = treat/nouni;
manova h=treat;
run;





TITLE 'PROB 5.18';
PROC IML;
  reset noprint;
  k=4;
  use app;
  read all var {y1 y2 y3 y4 y5 y6} into grand;
  n=nrow(grand);
  p=ncol(grand);
  nuh=k-1;
  nue = n-k;
  USE all;
  READ ALL VAR {y1 y2 y3 y4 y5 y6} INTO e where (_type_="ERROR");
  READ ALL VAR {y1 y2 y3 y4 y5 y6} INTO h where (_type_="SS3");
  use no1;
  read all var {y2 y3 y4 y5 y6} into e1 where(_type_="ERROR");
  read all var {y2 y3 y4 y5 y6} into h1 where(_type_="SS3");

  use no2;
  read all var {y1 y3 y4 y5 y6} into e2 where(_type_="ERROR");
  read all var {y1 y3 y4 y5 y6} into h2 where(_type_="SS3");

  use no3;
  read all var {y1 y2 y4 y5 y6} into e3 where(_type_="ERROR");
  read all var {y1 y2 y4 y5 y6} into h3 where(_type_="SS3");


  use no4;
  read all var {y1 y2 y3 y5 y6} into e4 where(_type_="ERROR");
  read all var {y1 y2 y3 y5 y6} into h4 where(_type_="SS3");


  use no5;
  read all var {y1 y2 y3 y4 y6} into e5 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y6} into h5 where(_type_="SS3");


  use no6;
  read all var {y1 y2 y3 y4 y5} into e6 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y5} into h6 where(_type_="SS3");

lamball = det(e)/det(e+h);
lamb1 = det(e1)/det(e1+h1);
lamb2 = det(e2)/det(e2+h2);
lamb3 = det(e3)/det(e3+h3);
lamb4 = det(e4)/det(e4+h4);
lamb5 = det(e5)/det(e5+h5);
lamb6 = det(e6)/det(e6+h6);

partl1 = lamball/lamb1;
partl2 = lamball/lamb2;
partl3 = lamball/lamb3;
partl4 = lamball/lamb4;
partl5 = lamball/lamb5;
partl6 = lamball/lamb6;



/* p was defined to equal the total number of variables.  In the partial */
/* F formular it is defined as the total number of variables - 1 */

partf1 = (1-partl1)/partl1*(nue - p +1)/nuh;
partf2 = (1-partl2)/partl2*(nue - p +1)/nuh;
partf3 = (1-partl3)/partl3*(nue - p +1)/nuh;
partf4 = (1-partl4)/partl4*(nue - p +1)/nuh;
partf5 = (1-partl5)/partl5*(nue - p +1)/nuh;
partf6 = (1-partl6)/partl6*(nue - p +1)/nuh;




print partf1 partf2 partf3 partf4 partf5 partf6;



  USE all;
  READ ALL VAR {y1 y2 y3 y4 y5 y6} INTO e where (_type_="ERROR");
  READ ALL VAR {y1 y2 y3 y4 y5 y6} INTO h where (_type_="SS3");
ein=inv(e);
f=root(ein);
a=f*h*f`;
call eigen(l,w,a);
v=f`*w;
print l,v;
quit;
endsas;
