options ls=72;

data bio;
infile 'tab4-11.dat';  
input treat y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2;
run;


proc candisc out=cand;
class treat;
var y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11;



proc glm data = bio outstat=all noprint;
class treat;
model y1-y11 = treat/nouni;
manova h=treat;
run;


proc glm data = bio outstat=no1 noprint;
class treat;
model y2-y11 = treat/nouni;
manova h=treat;
run;


proc glm data = bio outstat=no2 noprint;
class treat;
model y1 y3-y11 = treat/nouni;
manova h=treat;
run;


proc glm data = bio outstat=no3 noprint;
class treat;
model y1 y2 y4-y11 = treat/nouni;
manova h=treat;
run;

proc glm data = bio outstat=no4 noprint;
class treat;
model y1-y3 y5-y11 = treat/nouni;
manova h=treat;
run;


proc glm data = bio outstat=no5 noprint;
class treat;
model y1-y4 y6-y11 = treat/nouni;
manova h=treat;
run;

proc glm data = bio outstat=no6 noprint;
class treat;
model y1-y5 y7-y11 = treat/nouni;
manova h=treat;
run;

proc glm data = bio outstat=no7 noprint;
class treat;
model y1-y6 y8-y11 = treat/nouni;
manova h=treat;
run;

proc glm data = bio outstat=no8 noprint;
class treat;
model y1-y7 y9-y11 = treat/nouni;
manova h=treat;
run;

proc glm data = bio outstat=no9 noprint;
class treat;
model y1-y8 y10-y11 = treat/nouni;
manova h=treat;
run;

proc glm data = bio outstat=no10 noprint;
class treat;
model y1-y9 y11 = treat/nouni;
manova h=treat;
run;

proc glm data = bio outstat=no11 noprint;
class treat;
model y1-y10 = treat/nouni;
manova h=treat;
run;

PROC IML;
  reset noprint;
  k=4;
  use bio;
  read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} into grand;
  n=nrow(grand);
  p=ncol(grand);
  nuh=k-1;
  nue = n-k;
  USE all;
READ ALL VAR {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} INTO e where (_type_="ERROR");
READ ALL VAR {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} INTO h where (_type_="SS3");
  use no1;
  read all var {y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} into e1 where(_type_="ERROR");
  read all var {y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} into h1 where(_type_="SS3");

  use no2;
  read all var {y1 y3 y4 y5 y6 y7 y8 y9 y10 y11} into e2 where(_type_="ERROR");
  read all var {y1 y3 y4 y5 y6 y7 y8 y9 y10 y11} into h2 where(_type_="SS3");

  use no3;
  read all var {y1 y2 y4 y5 y6 y7 y8 y9 y10 y11} into e3 where(_type_="ERROR");
  read all var {y1 y2 y4 y5 y6 y7 y8 y9 y10 y11} into h3 where(_type_="SS3");


  use no4;
  read all var {y1 y2 y3 y5 y6 y7 y8 y9 y10 y11} into e4 where(_type_="ERROR");
  read all var {y1 y2 y3 y5 y6 y7 y8 y9 y10 y11} into h4 where(_type_="SS3");


  use no5;
  read all var {y1 y2 y3 y4 y6 y7 y8 y9 y10 y11} into e5 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y6 y7 y8 y9 y10 y11} into h5 where(_type_="SS3");


  use no6;
  read all var {y1 y2 y3 y4 y5 y7 y8 y9 y10 y11} into e6 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y5 y7 y8 y9 y10 y11} into h6 where(_type_="SS3");

  use no7;
  read all var {y1 y2 y3 y4 y5 y6 y8 y9 y10 y11} into e7 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y5 y6 y8 y9 y10 y11} into h7 where(_type_="SS3");

  use no8;
  read all var {y1 y2 y3 y4 y5 y6 y7 y9 y10 y11} into e8 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y5 y6 y7 y9 y10 y11} into h8 where(_type_="SS3");

  use no9;
  read all var {y1 y2 y3 y4 y5 y6 y7 y8 y10 y11} into e9 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y5 y6 y7 y8 y10 y11} into h9 where(_type_="SS3");

  use no10;
  read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y11} into e10 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y11} into h10 where(_type_="SS3");

  use no11;
  read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10} into e11 where(_type_="ERROR");
  read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10} into h11 where(_type_="SS3");



lamball = det(e)/det(e+h);
lamb1 = det(e1)/det(e1+h1);
lamb2 = det(e2)/det(e2+h2);
lamb3 = det(e3)/det(e3+h3);
lamb4 = det(e4)/det(e4+h4);
lamb5 = det(e5)/det(e5+h5);
lamb6 = det(e6)/det(e6+h6);
lamb7 = det(e7)/det(e7+h7);
lamb8 = det(e8)/det(e8+h8);
lamb9 = det(e9)/det(e9+h9);
lamb10 = det(e10)/det(e10+h10);
lamb11 = det(e11)/det(e11+h11);





partl1 = lamball/lamb1;
partl2 = lamball/lamb2;
partl3 = lamball/lamb3;
partl4 = lamball/lamb4;
partl5 = lamball/lamb5;
partl6 = lamball/lamb6;
partl7 = lamball/lamb7;
partl8 = lamball/lamb8;
partl9 = lamball/lamb9;
partl10 = lamball/lamb10;
partl11 = lamball/lamb11;



/* p was defined to equal the total number of variables.  In the partial */
/* F formular it is defined as the total number of variables - 1 */

partf1 = (1-partl1)/partl1*(nue - p +1)/nuh;
partf2 = (1-partl2)/partl2*(nue - p +1)/nuh;
partf3 = (1-partl3)/partl3*(nue - p +1)/nuh;
partf4 = (1-partl4)/partl4*(nue - p +1)/nuh;
partf5 = (1-partl5)/partl5*(nue - p +1)/nuh;
partf6 = (1-partl6)/partl6*(nue - p +1)/nuh;
partf7 = (1-partl7)/partl7*(nue - p +1)/nuh;
partf8 = (1-partl8)/partl8*(nue - p +1)/nuh;
partf9 = (1-partl9)/partl9*(nue - p +1)/nuh;
partf10 = (1-partl10)/partl10*(nue - p +1)/nuh;
partf11 = (1-partl11)/partl11*(nue - p +1)/nuh;




print partf1 partf2 partf3 partf4 partf5 partf6;
print partf7 partf8 partf9 partf10 partf11;
quit;
endsas;
