options ls=72;
data app;
infile 'tab4-10.dat'; 
input treat block y1 y2 y3 y4 y5 y6 x1 x2;
run;

proc glm data=app outstat=disc noprint;
class treat block ;
model y1-y6=treat|block /   nouni;
manova h=_all_ /;
run;
proc print data=disc;
proc iml;
use disc;
read all var {y1 y2 y3 y4 y5 y6 } into e where(_TYPE_='ERROR');
read all var {y1 y2 y3 y4 y5 y6 } into htb where(_SOURCE_ ='TREAT*BLOCK' &
_type_='SS3');
read all var {y1 y2 y3 y4 y5 y6 } into ht where(_SOURCE_ ='TREAT' & _type_='SS3');
read all var {y1 y2 y3 y4 y5 y6 } into hb where(_SOURCE_ ='BLOCK' & _type_='SS3');

u=root(e);
t=inv(u)`*ht*inv(u);
b=inv(u)`*hb*inv(u);
tb=inv(u)`*htb*inv(u);
uat=eigvec(t);
uab=eigvec(b);
uatb=eigvec(tb);
evt=eigval(t);
evb=eigval(b);
evtb=eigval(tb);
print 'Eigen values for Treatment';
print evt;
print 'Eigen values for Block';
print evb;
print 'Eigen values for Interaction';
print evtb;
at=inv(u)*uat;
ab=inv(u)*uab;
atb=inv(u)*uatb;
print 'Raw coefficients for Treatment',at ;
print 'Raw coefficients for Block',ab ;
print 'Raw coefficients for Interaction',atb ;
astd1=(sqrt(diag(e)))*at;
astd2=(sqrt(diag(e)))*ab;
astd3=(sqrt(diag(e)))*atb;
print 'Standardized coefficients for Treatment',astd1 ;
print 'Standardized coefficients for Block',astd2 ;
print 'Standardized coefficients for Interaction',astd3 ;

