********** 6.16 SAS code****************;
options ls=72;

data apple;

infile 'tab4-10.dat' ;
input group block y1 y2 y3 y4 y5 y6 x1 x2;

run;
/*
proc stepdisc stepwise simple stmean;
class group;
var y1 y2 y3 y4 y5 y6;
where group in (1,2);
title 'Problem 6.13' stepwise;
endsas;
*/
********************* Part b *****************************************;
/* the variables selected by proc stepdisc are y2,y3,y4 */
PROC IML;
  USE apple; 
  read all var {y2 y3 y4} into X1 where(group=1);
  read all var {y2 y3 y4} into X2 where(group=2);
  RESET noPRINT;
  N1 = NROW(X1);
  N2 = NROW(X2);
  p=ncol(x);
  x1BAR = 1/N1*X1`*J(N1,1);
  x2BAR = 1/N2*X2`*J(N2,1);
  
  S2 = 1/(N2-1)*X2`*(I(N2)-1/N2*J(N2))*X2;  
  S1 = 1/(N1-1)*X1`*(I(N1)-1/N1*J(N1))*X1; 
  Spl = 1/(N1+N2-2)*((N1-1)*S1+(N2-1)*S2);

class = .5*(x1bar - x2bar)`*inv(spl)*(x1bar + x2bar);
left = (x1bar - x2bar)`*inv(spl);
print 'Part b';
print 'Linear function of y, using only y2, y3, y4', left;
print 'Linear classification rule',class;


********* part a ********** assume p1=p2;
proc discrim data = apple outstat=ftstat
                method=normal pool=yes;
class group;
var y2 y3 y4;
where group in (1,2);
title 'Classification Analysis of apple data - part a';

run;
