options ls=72;

data soil;

infile 'tab4-10.dat';
input treat block y1 y2 y3 y4 y5 y6 x1 x2;
************* to find quadratic classification functions *****;
proc iml;
use soil;
reset noprint;
read all var {y1 y2 y3 y4 y5 y6} into y1 where(treat=1);
read all var {y1 y2 y3 y4 y5 y6} into y2 where(treat=2);
read all var {y1 y2 y3 y4 y5 y6} into y3 where(treat=3);
read all var {y1 y2 y3 y4 y5 y6} into y4 where(treat=4);
n1 = nrow(y1);
n2 = nrow(y2);
n3 = nrow(y3);
n4 = nrow(y4);

ybar1 = 1/n1*y1`*J(n1,1);
ybar2 = 1/n2*y2`*J(n2,1);
ybar3 = 1/n3*y3`*J(n3,1);
ybar4 = 1/n4*y4`*J(n4,1);

s1 = 1/(n1-1)*y1`*(I(n1) - 1/n1*J(n1))*y1;
s2 = 1/(n2-1)*y2`*(I(n2) - 1/n2*J(n2))*y2;
s3 = 1/(n3-1)*y3`*(I(n3) - 1/n3*J(n3))*y3;
s4 = 1/(n4-1)*y4`*(I(n4) - 1/n4*J(n4))*y4;

invs1 = det(s1);
invs2 = det(s2);
invs3 = det(s3);
invs4 = det(s4);
print invs1 invs2 invs3 invs4;

constq1 =  -.5*log(det(s1)) - .5*ybar1`*inv(s1)*ybar1;
vectorq1 = ybar1`*inv(s1);
constq2 =  -.5*log(det(s2)) - .5*ybar2`*inv(s2)*ybar2;
vectorq2 = ybar2`*inv(s2);
constq3 =  -.5*log(det(s3)) - .5*ybar3`*inv(s3)*ybar3;
vectorq3 = ybar3`*inv(s3);
constq4 =  -.5*log(det(s4)) - .5*ybar4`*inv(s4)*ybar4;
vectorq4 = ybar4`*inv(s4);


print "Quadratic classification functions";
print "Q(i) = vectorqi*y + constq1 + y`*inv(S)*y";
print constq1,vectorq1;
print constq2,vectorq2;
print constq3,vectorq3;
print constq4,vectorq4;

proc discrim data = soil outstat=ftstat
                method=normal pool=yes;
class treat;
var y1 y2 y3 y4 y5 y6;
title 'Classification Analysis of Apple data - part a and b';


proc discrim data = soil outstat=ftstat
                method=normal pool=no;
class treat;
var y1 y2 y3 y4 y5 y6;
title 'Classification Analysis of Apple data - part c and d';



